// neoPLC BMX055 library test
// Austin Gurley
// 8-27-16

#include "neoPLC_IMU.h"

neoPLC_IMU BMX = neoPLC_IMU();

int success = 0;
float ax, ay, az, gx, gy, gz, mx, my, mz;
bool led_state = 0;
int dt = 0;
int dt_true = 0;

void setup() 
{
  Serial.begin(115200);
  delay(2000);
  Serial.println("Deft IMU test");

/* potential values for setup:
Accelerometer Range:
  2, 4, 8, 16 (Gs) | default: 2
Accelerometer Bandwidth:
  8, 16, 32, 64, 125, 250, 500, 1000 (Hz) | default: 125
Gyroscope Range:
  125, 250, 500, 1000, 2000 (deg/s) | default: 250
Gyroscope Bandwidth:
  12, 23, 32, 47, 64, 116, 230, 523 (Hz) | default: 116
Magnetometer Output Rate:
  2, 6, 8, 10, 15, 20, 25, 30 (Hz) | default: 30
*/
// settings: acc_range, acc_bw, gyro_range, gyro_bw, mag_odr
  success = BMX.begin(8,64,250,64,30);
  
  if (!success)
  {
     Serial.println("Failed to initialize BMX055");
     while(1){}
  }
  pinMode(13,OUTPUT);
}

void loop() 
{
    BMX.readAccel(&ax, &ay, &az); // retrieve acceleration in Gs IF new data is available
    BMX.readGyro(&gx, &gy, &gz); // retrieve rotation rate in deg/s 
    BMX.readMag(&mx, &my, &mz); // retrieve magnetic flux in mGauss IF new data is available
    

    // loop regulation
    while((micros()-dt)<10000){}
    dt = micros();
    
    Serial.printf("ax = %2.4f\t ay = %2.4f\t az = %2.4f\t (g)\n",ax,ay,az);
    Serial.printf("gx = %2.4f\t gy = %2.4f\t gz = %2.4f\t (deg/s)\n",gx,gy,gz);
    Serial.printf("mx = %2.4f\t my = %2.4f\t mz = %2.4f\t (mG)\n\n",mx,my,mz);
    
    led_state = !led_state;              
    digitalWrite(13, led_state);   // turn the LED on (HIGH is the voltage level)
}
